SystemOrganization addCategory: #Rest!
SystemOrganization addCategory: #'Rest-Tests'!
SystemOrganization addCategory: #'Rest-Handlers'!
SystemOrganization addCategory: #'Rest-Services'!
SystemOrganization addCategory: #'Rest-Handler'!

!HTTPSocket class methodsFor: '*rest-tests' stamp: 'cs 2/15/2009 15:47'!
httpDelete: t1
	| t5 |
	t5 := self
				httpDeleteDocument: t1
				args: nil
				accept: '*/*'
				request: ''.
	t5 isString
		ifTrue: [^ t5].
	^ (RWBinaryOrTextStream with: t5 content) reset! !

!HTTPSocket class methodsFor: '*rest-tests' stamp: 'cs 2/15/2009 15:44'!
httpDeleteDocument: t1 args: t2 accept: t3 request: t4 
	| t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 |
	Socket initializeNetwork.
	t11 := (t1 asLowercase beginsWith: 'http://')
				ifTrue: [t1 copyFrom: 8 to: t1 size]
				ifFalse: [t1].
	t11 := t11 copyUpTo: $#.
	t5 := t11 copyUpTo: $/.
	t12 := t11 copyFrom: t5 size + 1 to: t11 size.
	(t5 includes: $:)
		ifTrue: [t16 := t5 indexOf: $:.
			t7 := (t5 copyFrom: t16 + 1 to: t5 size) asNumber.
			t5 := t5 copyFrom: 1 to: t16 - 1]
		ifFalse: [t7 := self defaultPort].
	t12 size = 0
		ifTrue: [t12 := '/'].
	t2
		ifNotNil: [t12 := t12
						, (self argString: t2)].
	(self shouldUseProxy: t5)
		ifTrue: [t12 := 'http://' , t5 , ':' , t7 printString , t12.
			t17 := self httpProxyServer.
			t18 := self httpProxyPort]
		ifFalse: [t17 := t5.
			t18 := t7].
	t6 := NetNameResolver addressForName: t17 timeout: 20.
	t6
		ifNil: [^ 'Could not resolve the server named: ' , t17].
	3
		timesRepeat: [t8 := HTTPSocket new.
			t8 connectTo: t6 port: t18.
			(t8
					waitForConnectionUntil: (self deadlineSecs: 30))
				ifFalse: [Socket deadServer: t17.
					t8 destroy.
					^ 'Server ' , t17 , ' is not responding'].
			t8 sendCommand: 'DELETE ' , t12 , ' HTTP/1.0' , CrLf
					, (t3
							ifNil: ['']
							ifNotNil: ['ACCEPT: ' , t3 , CrLf]) , 'ACCEPT: text/html' , CrLf , HTTPBlabEmail , t4 , self userAgentString , CrLf , 'Host: ' , t5 , ':' , t7 printString , CrLf.
			t13 := t8
						getResponseUpTo: CrLf , CrLf
						ignoring: (String with: CR).
			t9 := t13 at: 1.
			t14 := t13 at: 3.
			t9 isEmpty
				ifTrue: [t15 := 'server aborted early']
				ifFalse: [t8 header: t9.
					t10 := t8 getHeader: 'content-length'.
					t10
						ifNotNil: [t10 := t10 asNumber].
					t19 := t8 getHeader: 'content-type'.
					t8 responseCode first = $3
						ifTrue: [t20 := t8 getHeader: 'location'.
							t20
								ifNotNil: [Transcript show: 'redirecting to ' , t20;
										 cr.
									t8 destroy.
									t20 := self
												expandUrl: t20
												ip: t6
												port: t18.
									^ self
										httpGetDocument: t20
										args: t2
										accept: t3
										request: t4]].
					t15 := t8 getRestOfBuffer: t14 totalLength: t10.
					t8 responseCode first = $4
						ifTrue: [^ t9 , t15 contents].
					nil].
			t8 destroy.
			t15 class ~~ String
				ifTrue: [^ MIMEDocument
						contentType: t19
						content: t15 contents
						url: t1].
			t15 = 'server aborted early'
				ifTrue: [^ t15].
			nil].
	{'HTTPSocket class>>httpGetDocument:args:accept:request:'. t15. t1} inspect.
	^ 'some other bad thing happened!!'! !

!HTTPSocket class methodsFor: '*rest-tests' stamp: 'cs 2/15/2009 15:50'!
httpPut: t1 args: t2
	| t4 |
	t4 := self
				httpPutDocument: t1
				args: t2
				accept: '*/*'
				request: ''.
	t4 isString
		ifTrue: [^ t4].
	^ RWBinaryOrTextStream with: t4 content! !

!HTTPSocket class methodsFor: '*rest-tests' stamp: 'cs 2/16/2009 01:42'!
httpPutDocument: t1 args: t2 accept: t3 request: t4 
	| t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 |
	Socket initializeNetwork.
	t14 := Url absoluteFromText: t1.
	t8 := t14 fullPath.
	t15 := t2
				ifNil: ['']
				ifNotNil: [t15 := self argString: t2.
					t15 first = $?
						ifTrue: [t15 := t15 copyFrom: 2 to: t15 size]].
	t5 := HTTPSocket new.
	t5 := self
				initHTTPSocket: t14
				wait: (self deadlineSecs: 30)
				ifError: [:t16 | ^ t16].
	t5 sendCommand: 'PUT ' , t8 , ' HTTP/1.0' , CrLf
			, (t3
					ifNil: ['']
					ifNotNil: ['ACCEPT: ' , t3 , CrLf]) , 'ACCEPT: text/html' , CrLf , HTTPProxyCredentials , HTTPBlabEmail , t4 , self userAgentString , CrLf , 'Content-type: application/x-www-form-urlencoded' , CrLf , 'Content-length: ' , t15 size printString , CrLf , 'Host: ' , t14 authority , CrLf.
	t5 sendCommand: t15.
	t9 := t5
				getResponseUpTo: CrLf , CrLf
				ignoring: (String with: CR).
	t6 := t9 at: 1.
	t10 := t9 at: 3.
	t5 header: t6.
	t7 := t5 getHeader: 'content-length'.
	t7
		ifNotNil: [t7 := t7 asNumber].
	t12 := t5 getHeader: 'content-type'.
	t5 responseCode first = $3
		ifTrue: [t13 := t5 getHeader: 'location'.
			t13
				ifNotNil: [t13 := (t14 newFromRelativeText: t13) asString.
					self flag: #refactor.
					t5 destroy.
					^ self httpGetDocument: t13 accept: t3]].
	t11 := t5 getRestOfBuffer: t10 totalLength: t7.
	t5 responseCode = '401'
		ifTrue: [^ t6 , t11 contents].
	t5 destroy.
	^ MIMEDocument
		contentType: t12
		content: t11 contents
		url: t1! !

HttpService subclass: #RestHttpService
	instanceVariableNames: 'handlers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Services'!

RestHttpService class
	instanceVariableNames: 'service port'!

RestHttpService class
	instanceVariableNames: 'service port'!

!RestHttpService class methodsFor: 'as yet unclassified' stamp: 'cs 2/15/2009 14:21'!
createService
	^ RestHttpService on: self port.! !

!RestHttpService class methodsFor: 'as yet unclassified' stamp: 'bs 2/13/2009 15:06'!
port
	^8082! !

!RestHttpService class methodsFor: 'as yet unclassified' stamp: 'cs 2/15/2009 14:16'!
run
	self stop.
	service := self createService.
	^ service
		start;
		yourself! !

!RestHttpService class methodsFor: 'as yet unclassified' stamp: 'mt 1/30/2009 13:28'!
stop
	service ifNotNil:
		[service unregister.
		service := nil].
	port := nil.! !

!RestHttpService methodsFor: 'initialization' stamp: 'mt 2/2/2009 10:12'!
initialize
	super initialize.
	handlers := OrderedCollection new	"needed for priorities"! !

!RestHttpService methodsFor: 'serving' stamp: 'cs 2/15/2009 16:07'!
installHandler: aRequestHandlerClass on: aPathString
	(handlers anySatisfy: [:ass | ass key = aPathString ])
		ifTrue: [^ false].
	handlers add: aPathString -> aRequestHandlerClass! !

!RestHttpService methodsFor: 'serving' stamp: 'test 2/15/2009 16:13'!
processHttpRequest: request
	
	| activeHandler path |
	activeHandler := (handlers detect: [:ass| 
		path := ass key.
		request url includesSubString: path
		]) value.
	^(activeHandler new) process: request! !

!XpfEntity methodsFor: '*rest' stamp: 'cs 2/16/2009 00:40'!
jsonWriteOn: aStream
	self id jsonWriteOn: aStream! !

!Collection methodsFor: '*rest' stamp: 'cs 2/16/2009 00:38'!
jsonWriteOn: aStream
	| needComma |
	needComma := false.
	aStream nextPut: $[.
	self do: [:v |
		needComma
			ifTrue: [ aStream nextPutAll: ', ' ]
			ifFalse: [ needComma := true ].
		v jsonWriteOn: aStream.
	].
	aStream nextPut: $].! !

Object subclass: #RestHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Handlers'!

!RestHttpHandler methodsFor: 'request processing' stamp: 'cs 2/15/2009 14:01'!
process: anHttpRequest
	self subclassResponsibility! !

RestHttpHandler subclass: #RestPerformHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Handlers'!

!RestPerformHttpHandler methodsFor: 'request processing' stamp: 'mt 2/14/2009 14:26'!
process: anHttpRequest
	"Takes second element in path as classname and sends message from third path element to that class."

	|pc class selector result|
	pc := (URI fromString: anHttpRequest url) pathComponents.
	class := pc second asSymbol.
	selector := pc third asSymbol.
	
	Smalltalk at: class ifPresent: [:c | 
		(c class allSelectors includes: selector) ifTrue: [
			result := c perform: selector]].

	^ HttpResponse fromString: result printString.! !

RestHttpHandler subclass: #RestResourceHttpHandler
	instanceVariableNames: 'resources'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Handlers'!

!RestResourceHttpHandler methodsFor: 'creating' stamp: 'cs 2/15/2009 17:54'!
create: resource from: fields
	| entity |
	entity := resource new.
	fields keysAndValuesDo: [:key :value |
		entity instVarNamed: key asString put: value first].
	resource perform: ('add', (self resolveName: resource) capitalized, ':') asSymbol with: entity.
	^ HttpResponse status: #ok contents: entity id asString! !

!RestResourceHttpHandler methodsFor: 'reading' stamp: 'cs 2/16/2009 01:26'!
delete: resource id: id
	| entity |
	entity := resource all
		detect: [:each | each id = id]
		ifNone: [^ self notFound: resource id: id].
	resource
		perform: ('delete', (self resolveName: resource) capitalized, ':') asSymbol
		with: entity.
	^ HttpResponse status: #ok contents: 'deleted'.! !

!RestResourceHttpHandler methodsFor: 'private' stamp: 'cs 2/15/2009 17:02'!
failure: anHttpRequest

	^ nil asHttpResponseTo: anHttpRequest! !

!RestResourceHttpHandler methodsFor: 'initialization' stamp: 'cs 2/15/2009 16:54'!
initialize

	super initialize.
	self initializeResources.! !

!RestResourceHttpHandler methodsFor: 'initialization' stamp: 'cs 2/15/2009 17:09'!
initializeResources
	
	resources :=
		(XpfEntity allSubclasses
			collect: [:aClass | (aClass name asLowercase
				atAll: (4 to: aClass name size)) -> aClass])
			inject: Dictionary new
			into: [:old :each | old at: each key put: each value; yourself]! !

!RestResourceHttpHandler methodsFor: 'private' stamp: 'cs 2/16/2009 00:50'!
notFound: resource id: id
	^ HttpResponse
		status: #notFound
		contents:
			(self resolveName: resource capitalized),
			' with id ', id asString,
			' not found.'! !

!RestResourceHttpHandler methodsFor: 'request processing' stamp: 'cs 2/16/2009 01:45'!
process: anHttpRequest 
	| pc resource id |
	pc := (URI fromString: anHttpRequest url) pathComponents.
	resource := pc second.
	resource := self resolveResource: resource ifAbsent: [^ self failure: anHttpRequest].
	pc size > 2 ifTrue: [id := pc third asNumber].
	anHttpRequest isPostRequest ifTrue: [^ self create: resource from: anHttpRequest postFields].
	(anHttpRequest isGetRequest and: [id isNil]) ifTrue: [^ self read: resource].
	(anHttpRequest isGetRequest and: [id isNil not]) ifTrue: [^ self read: resource id: id].
	anHttpRequest isPutRequest ifTrue: [^ self update: resource from: anHttpRequest postFields id: id].
	anHttpRequest isDeleteRequest ifTrue: [^ self delete: resource id: id].! !

!RestResourceHttpHandler methodsFor: 'reading' stamp: 'cs 2/16/2009 00:59'!
read: resource
	| response |
	response := resource all collect: [:entity|
		resource allInstVarNames
			inject: Dictionary new
			into: [:old :name| old at: name put: (entity instVarNamed: name); yourself]].
	^ HttpResponse status: #ok contents: (Json render: response).! !

!RestResourceHttpHandler methodsFor: 'reading' stamp: 'cs 2/16/2009 00:58'!
read: resource id: id
	| entity response |
	entity := resource all
		detect: [:each | each id = id]
		ifNone: [^ self notFound: resource id: id].
	response := Dictionary new.
	XpfProject allInstVarNames do:
		[:name| response at: name put: (entity instVarNamed: name)].
	^ HttpResponse status: #ok contents: (Json render: response).! !

!RestResourceHttpHandler methodsFor: 'private' stamp: 'cs 2/15/2009 17:29'!
resolveName: aClass

	resources keysAndValuesDo: [:key :value |
		value = aClass ifTrue: [^ key]].
	^ nil.! !

!RestResourceHttpHandler methodsFor: 'private' stamp: 'cs 2/15/2009 17:13'!
resolveResource: resource ifAbsent: aBlock

	(resource endsWith: 'ies')
		ifTrue:[^ resources at: (resource truncateTo: resource size - 3, 'y') ifAbsent: aBlock].
	(resource endsWith: 's')
		ifTrue:[^ resources at: (resource truncateTo: resource size - 1) ifAbsent: aBlock].
	resources at: resource ifAbsent: aBlock.! !

!RestResourceHttpHandler methodsFor: 'creating' stamp: 'test 2/16/2009 01:47'!
update: resource from: fields id: id
	| entity |
	entity := resource all
		detect: [:each | each id = id]
		ifNone: [^ self notFound: resource id: id].
	fields keysAndValuesDo: [:key :value |
		entity instVarNamed: key asString put: value first].
	^ HttpResponse status: #ok contents: 'updated'! !

Object subclass: #RestLogService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Services'!

!RestLogService class methodsFor: 'service' stamp: 'cs 2/7/2009 14:20'!
log: aCollection
	Transcript show: aCollection first asString; cr.! !

TestCase subclass: #RestTest
	instanceVariableNames: 'service'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests'!

RestTest subclass: #RestPerformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests'!

!RestPerformTest methodsFor: 'running' stamp: 'cs 2/15/2009 14:06'!
setUp
	super setUp.
	service 
		installHandler: RestPerformHttpHandler
		on: '/perform'! !

!RestPerformTest methodsFor: 'tests' stamp: 'cs 2/15/2009 16:39'!
testPort
	| response |
	response := self get: '/perform/RestHttpService/port'.
	self should: response contents = RestHttpService port asString.! !

RestTest subclass: #RestResourceTest
	instanceVariableNames: 'testProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests'!

!RestResourceTest methodsFor: 'running' stamp: 'cs 2/15/2009 17:36'!
setUp
	super setUp.
	service 
		installHandler: RestResourceHttpHandler
		on: '/resources'.
	testProject := XpfProject addProject:
		(XpfProject new
			title: 'TestProjekt';
			yourself).! !

!RestResourceTest methodsFor: 'running' stamp: 'cs 2/16/2009 01:29'!
tearDown
	super tearDown.
	(XpfProject all includes: testProject)
		ifTrue: [XpfProject deleteProject: testProject]! !

!RestResourceTest methodsFor: 'tests' stamp: 'cs 2/16/2009 01:17'!
testCreateProject
	| response projectCount newProject |
	projectCount := XpfProject all size.
	response := self
		post: '/resources/projects/'
		fields: (Dictionary
			with: 'title' -> 'Test').
	self should: XpfProject all size = (projectCount + 1).
	newProject := XpfProject all detect:
		[:aProject | aProject id = response asNumber].
	self should: newProject title = 'Test'.! !

!RestResourceTest methodsFor: 'tests' stamp: 'cs 2/15/2009 16:34'!
testCreateUserStory
	| response storyCount newStory |
	self fail.
	storyCount := testProject userStories size.
	response := self
		post: '/resources/userstories/'
		fields: (Dictionary
			with: 'title' -> 'Test'
			with: 'priority' -> 5
			with: 'timeEstimated' -> 42
			with: 'project' -> 23).
	self should: testProject userStories size = (storyCount + 1).
	newStory := testProject userStories last.
	self should: newStory id = response contents asNumber.
	self should: newStory title = 'Test'.
	self should: newStory priority = 5.
	self should: newStory timeEstimated = 42.
	self should: newStory project = testProject.! !

!RestResourceTest methodsFor: 'tests' stamp: 'cs 2/16/2009 01:22'!
testDeleteProject
	| projectCount |
	projectCount := XpfProject all size.
	self delete: '/resources/projects/', testProject id asString.
	self should: XpfProject all size = (projectCount - 1).
	self shouldnt:
		(XpfProject all anySatisfy:
			[:aProject | aProject id = testProject id]).! !

!RestResourceTest methodsFor: 'tests' stamp: 'cs 2/16/2009 00:55'!
testReadProject
	| response |	
	response := self get: '/resources/projects/', testProject id asString.
	response := Json readFrom: (ReadStream on: response).
	self should: testProject title = (response at: 'title').
	self should: testProject id = (response at: 'id').! !

!RestResourceTest methodsFor: 'tests' stamp: 'cs 2/16/2009 00:56'!
testReadProjects
	| response responseProject |
	response := self get: '/resources/projects/'.
	response := Json readFrom: (ReadStream on: response).
	self should: XpfProject all size = response size.
	responseProject := response detect: [:each| (each at: 'id') = testProject id].
	self should: testProject title = (responseProject at: 'title').
	self should: testProject id = (responseProject at: 'id').! !

!RestResourceTest methodsFor: 'tests' stamp: 'cs 2/16/2009 01:21'!
testUpdateProject
	| projectCount |
	projectCount := XpfProject all size.
	self
		put: '/resources/projects/', testProject id asString
		fields: (Dictionary
			with: 'title' -> 'NewTest').
	self should: XpfProject all size = projectCount.
	self should: testProject title = 'NewTest'.! !

!RestTest class methodsFor: 'testing' stamp: 'cs 2/15/2009 14:14'!
isAbstract
	^ self name = 'RestTest'! !

!RestTest methodsFor: 'helping' stamp: 'cs 2/15/2009 17:07'!
delete: aString
	^ (HTTPSocket httpDelete:
		'http://localhost:',
		RestHttpService port asString,
		aString) contents asString.! !

!RestTest methodsFor: 'helping' stamp: 'cs 2/15/2009 17:07'!
get: aString
	^ (HTTPSocket httpGet:
		'http://localhost:',
		RestHttpService port asString,
		aString) contents asString.! !

!RestTest methodsFor: 'helping' stamp: 'cs 2/15/2009 17:07'!
post: aString fields: aDictionary
	^ (HTTPSocket
		httpPost:
			'http://localhost:',
			RestHttpService port asString,
			aString
		args:
			(aDictionary associations
				inject: Dictionary new
				into: [:old :each |
				old at: each key put: {each value}; yourself])
		accept: '*/*') contents asString! !

!RestTest methodsFor: 'helping' stamp: 'cs 2/15/2009 17:08'!
put: aString fields: aDictionary
	^ (HTTPSocket
		httpPut:
			'http://localhost:',
			RestHttpService port asString,
			aString
		args:
			(aDictionary associations
				inject: Dictionary new
				into: [:old :each |
				old at: each key put: {each value}; yourself])) contents asString! !

!RestTest methodsFor: 'running' stamp: 'cs 2/15/2009 16:07'!
setUp
	service := RestHttpService run.
	"wait until the service is up"
	(Delay forMilliseconds: 100) wait.! !

!RestTest methodsFor: 'running' stamp: 'cs 2/15/2009 14:27'!
tearDown
	RestHttpService stop.! !
